## qtmips 0.8.1

=== CMakeLists.txt ===
--- 
+++ 
@@ -3,7 +3,7 @@
 
 project(QtMips
         LANGUAGES C CXX
-        VERSION 0.8.0
+        VERSION 0.8.1
         DESCRIPTION "MIPS CPU simulator for education purposes")
 
 set(KAREL_KOCI "Karel Koci <cynerd@email.cz>")
@@ -14,7 +14,7 @@
 set(GENERIC_NAME "MIPS CPU simulator")
 set(LICENCE "GPL-3.0-or-later")
 set(LONG_DESCRIPTION
-    "RISC-V CPU simulator for education purposes with pipeline and cache visualization.")
+    "MIPS CPU simulator for education purposes with pipeline and cache visualization.")
 string(TIMESTAMP YEAR "%Y")
 
 include(cmake/CopyrightTools.cmake)
@@ -23,8 +23,7 @@
 copyright(
     "Copyright (c) 2017-2019 ${KAREL_KOCI}"
     "Copyright (c) 2019-${YEAR} ${PAVEL_PISA}"
-	"Copyright (c) 2020-${YEAR} ${JAKUB_DUPAK}"
-    "Copyright (c) 2020-${YEAR} ${MAX_HOLLMANN}")
+	"Copyright (c) 2020-${YEAR} ${JAKUB_DUPAK}")
 
 include(cmake/GPL-3.0-or-later.cmake)
 
@@ -44,7 +43,7 @@
     CACHE STRING "Absolute path to place executables to.")
 set(PACKAGE_OUTPUT_PATH "${EXECUTABLE_OUTPUT_PATH}/pkg"
     CACHE STRING "Absolute path to place generated package files.")
-
+set(FORCE_COLORED_OUTPUT false CACHE BOOL "Always produce ANSI-colored output (GNU/Clang only).")
 
 # =============================================================================
 # Generated variables
@@ -90,22 +89,31 @@
 set(CMAKE_CXX_STANDARD 14)
 set(CMAKE_CXX_STANDARD_REQUIRED ON)
 
-if(NOT "${SANITIZERS}" MATCHES "none" AND NOT "${WASM}")
+if(NOT "${SANITIZERS}" MATCHES "none" AND NOT "${WASM}" AND NOT "${MINGW}")
 	set(CMAKE_C_FLAGS_DEBUG
-	    "${CMAKE_C_FLAGS_DEBUG} -fno-omit-frame-pointer -fsanitize=${SANITIZERS} -g -g3 -ggdb")
+			"${CMAKE_C_FLAGS_DEBUG} -fno-omit-frame-pointer -fsanitize=${SANITIZERS} -g -g3 -ggdb")
 	set(CMAKE_CXX_FLAGS_DEBUG
-	    "${CMAKE_CXX_FLAGS_DEBUG} -fno-omit-frame-pointer -fsanitize=${SANITIZERS} -g -g3 -ggdb")
+			"${CMAKE_CXX_FLAGS_DEBUG} -fno-omit-frame-pointer -fsanitize=${SANITIZERS} -g -g3 -ggdb")
 	set(CMAKE_LINKER_FLAGS_DEBUG
-	    "${CMAKE_LINKER_FLAGS_DEBUG} -fno-omit-frame-pointer -fsanitize=${SANITIZERS}")
+			"${CMAKE_LINKER_FLAGS_DEBUG} -fno-omit-frame-pointer -fsanitize=${SANITIZERS}")
 endif()
 
 
 if("${BUILD_RELEASE}")
 	message(STATUS "Debug prints globally suppressed.")
-	add_compile_definitions(QT_NO_DEBUG_OUTPUT=1)
+	add_definitions(-DQT_NO_DEBUG_OUTPUT=1)
 endif()
 
 include_directories("src" "src/machine")
+
+
+if(${FORCE_COLORED_OUTPUT})
+	if("${CMAKE_CXX_COMPILER_ID}" STREQUAL "GNU")
+		add_compile_options(-fdiagnostics-color=always)
+	elseif("${CMAKE_CXX_COMPILER_ID}" STREQUAL "Clang")
+		add_compile_options(-fcolor-diagnostics)
+	endif()
+endif()
 
 ## ============================================================================
 ## Warning level
@@ -116,7 +124,7 @@
 else()
 	add_compile_options(-Wall -Wextra)
 	if(CMAKE_CXX_COMPILER_ID STREQUAL "Clang")
-		# This is currently a wontfix and it will be OK in cpp20.
+		# This is currently a wont-fix and it will be OK in cpp20.
 		add_compile_options(-Wno-c99-designator)
 	endif()
 endif()
@@ -129,6 +137,8 @@
 	message(STATUS "WASM build detected")
 
 	message(STATUS "Enabled WASM exception handling")
+	add_compile_options("-fexceptions")
+	add_link_options("-fexceptions")
 	add_link_options("SHELL:-s DISABLE_EXCEPTION_CATCHING=0")
 	# Extra options for WASM linking
 	add_link_options("SHELL:-s FETCH=1")
@@ -140,7 +150,7 @@
 	add_link_options("SHELL:-s EXTRA_EXPORTED_RUNTIME_METHODS=[\"UTF16ToString\",\"stringToUTF16\"]")
 	add_link_options("--bind")
 
-	add_compile_definitions(QT_NO_DEBUG_OUTPUT=1)
+	add_definitions(-DQT_NO_DEBUG_OUTPUT=1)
 	message(STATUS "Debug output disabled")
 
 else()
@@ -164,12 +174,25 @@
 	add_subdirectory("external/libelf")
 endif()
 
-find_package(Qt5
+# Detect Qt used qt version
+# Based on article https://www.steinzone.de/wordpress/how-to-support-both-qt5-and-qt6-using-cmake/
+# Cannot use version-less approach due to Qt 5.9.5 support constraint.
+find_package(OpenGL)
+
+find_package(QT NAMES Qt6 Qt5 COMPONENTS Core REQUIRED)
+# Normally, we would use variable Qt5 or Qt6 to reference the Qt library. Here we do that through
+# this variable based on detected version major of Qt.
+set(QtLib "Qt${QT_VERSION_MAJOR}")
+find_package(${QtLib}
              REQUIRED COMPONENTS Core Widgets Gui Test
              OPTIONAL_COMPONENTS PrintSupport)
 
-message(STATUS "Qt5 version: ${Qt5Core_VERSION}")
-message(STATUS "Qt5 print support: ${Qt5PrintSupport_FOUND}")
+message(STATUS "${QtLib} version: ${${QtLib}Core_VERSION}")
+message(STATUS "${QtLib} print support: ${${QtLib}PrintSupport_FOUND}")
+
+
+# Qt 5.9.5 is the oldest supported
+add_definitions(-DQT_DISABLE_DEPRECATED_BEFORE=0x050905)
 
 # =============================================================================
 # Sources
@@ -182,6 +205,8 @@
 add_subdirectory("src/gui")
 if(NOT "${WASM}")
 	add_subdirectory("src/cli")
+	add_custom_target(all_unit_tests
+			DEPENDS common_unit_tests machine_unit_tests)
 endif()
 
 # =============================================================================
