=== src/assembler/CMakeLists.txt ===
--- 
+++ 
@@ -17,4 +17,4 @@
         ${assembler_SOURCES}
         ${assembler_HEADERS})
 target_link_libraries(assembler
-        PRIVATE Qt5::Core)
+        PRIVATE ${QtLib}::Core)
