=== src/gui/CMakeLists.txt ===
--- 
+++ 
@@ -145,7 +145,7 @@
                ${gui_RESOURCES})
 target_include_directories(gui PUBLIC . coreview)
 target_link_libraries(gui
-        PRIVATE Qt5::Core Qt5::Widgets Qt5::Gui
+        PRIVATE ${QtLib}::Core ${QtLib}::Widgets ${QtLib}::Gui
         PRIVATE machine os_emulation assembler)
 target_compile_definitions(gui
                            PRIVATE
@@ -158,8 +158,8 @@
 set_target_properties(gui PROPERTIES
                       OUTPUT_NAME "${MAIN_PROJECT_NAME_LOWER}_${PROJECT_NAME}")
 
-if(${Qt5PrintSupport_FOUND})
-    target_link_libraries(gui PRIVATE Qt5::PrintSupport)
+if(${${QtLib}PrintSupport_FOUND})
+    target_link_libraries(gui PRIVATE ${QtLib}::PrintSupport)
     target_compile_definitions(gui PRIVATE WITH_PRINTING=1)
 endif()
