=== src/os_emulation/CMakeLists.txt ===
--- 
+++ 
@@ -16,4 +16,4 @@
         ${os_emulation_SOURCES}
         ${os_emulation_HEADERS})
 target_link_libraries(os_emulation
-        PRIVATE Qt5::Core)
+        PRIVATE ${QtLib}::Core)
