=== debian/control ===
--- 
+++ 
@@ -12,4 +12,4 @@
 Architecture: any
 Depends: ${shlibs:Depends}, ${misc:Depends}
 Description: MIPS CPU simulator for education purposes
- RISC-V CPU simulator for education purposes with pipeline and cache visualization.
+ MIPS CPU simulator for education purposes with pipeline and cache visualization.
